/*
IXBTree.h
Copyright 1991, NeXT, Inc.
*/

#import <mach/cthreads.h>
#import	<objc/Object.h>

#import	"protocols.h"

#import	<store/IXStoreFile.h>

#ifdef	NX_COMPILER_RELEASE_3_0
@interface IXBTree: Object <IXNameAndFileAccess, IXComparatorSetting, IXComparisonSetting>
#else
@interface IXBTree: Object
#endif
{
@public
    struct mutex	mutexLock;
#ifdef	NX_COMPILER_RELEASE_3_0
@protected
#endif
    vm_offset_t		_rootOffset;
    unsigned		_recordCount;
    unsigned		_syncVersion;
    unsigned		_codeVersion;
    unsigned		_blockShift;
    unsigned		_btreeDepth;
    boolean_t		_freeStore;
    char		*_handleName;
    unsigned		_handle;
    IXStore		*_store;
    IXComparator	*_comparator;
    void		*_context;
    char		*_comparison;
    struct BTreeStore	*_btreeStore;
    struct		{
	unsigned	isSpanning:1;
	unsigned	rightRotation:1;
	unsigned	leftRotation:1;
    }			_cursorStatus;
}


- (IXStore *)store;

- (unsigned)count;
- empty;

- compact;
- (unsigned)keyLimit;

- optimizeForTime;
- optimizeForSpace;






- setSpanning:(BOOL)flag;




#define	IXLockBTreeMutex(btree)	mutex_lock(&(btree)->mutexLock)
#define IXUnlockBTreeMutex(btree) mutex_unlock(&(btree)->mutexLock)

@end
