/*
IXBTreeCursor.h
Copyright 1991, NeXT, Inc.
*/

#import	"IXBTree.h"

#ifdef	NX_COMPILER_RELEASE_3_0
@interface IXBTreeCursor : Object <IXCursorPositioning>
#else
@interface IXBTreeCursor : Object
#endif
{
    struct BTree		*btree;
    void			*keyBuffer;
    unsigned			keyLength;
    unsigned			bufferSize;
    unsigned			storeVersion;
    unsigned			keyLimit;
    unsigned			traceHint;
    unsigned			cursorVersion;
    unsigned			cursorDepth;
    NXZone			*cursorZone;
    struct BTreeTraceRecord	*cursorTrace;
    struct			{
	unsigned		isSpanning:1;
	unsigned		rightRotation:1;
	unsigned		leftRotation:1;
	unsigned		traceNeeded:1;
	unsigned		traceOpened:1;
	unsigned		zeroPosition:1;
	unsigned		lastPosition:1;
    }				cursorStatus;
}

- (IXBTree *)btree;
- initWithBTree:(IXBTree *)aBTree;








- (BOOL)isSynchronized;
- (unsigned)changeCount;





- (unsigned)readValue:(void **)value;
- (unsigned)readRange:(void **)value
    ofLength:(unsigned)length atOffset:(unsigned)offset;

- removeValue;

- (BOOL)writeValue:(const void *)value
    andLength:(unsigned)length;
- writeRange:(const void *)value 
    ofLength:(unsigned)length atOffset:(unsigned)offset;



- readObject;
- readObjectFromZone:(NXZone *)zone;
- (BOOL)writeObject:anObject;





- (unsigned)openRange:(void **)value 
    ofLength:(unsigned)length atOffset:(unsigned)offset 
    forWriting:(BOOL)writing;





- (BOOL)getKey:(void **)key
    andLength:(unsigned *)length withHint:(unsigned *)hint;
- (BOOL)setKey:(const void *)key
    andLength:(unsigned)length withHint:(unsigned)hint;

@end
