/*
IXStoreDirectory.h
Copyright 1991, NeXT Computer, Inc.
*/

#import	<objc/Object.h>
#import	<store/IXStoreFile.h>

#ifdef	NX_COMPILER_RELEASE_3_0
@class IXBTreeCursor;
#endif






#ifdef	NX_COMPILER_RELEASE_3_0
@interface IXStoreDirectory: Object <IXNameAndFileAccess>
#else
@interface IXStoreDirectory: Object
#endif
{
    BOOL		_freeStore;
    char		*_handleName;
    unsigned		_handle;
    IXStore		*_store;
#ifdef	NX_COMPILER_RELEASE_3_0
    IXBTreeCursor       *_btreeCursor;
#else
    id                  _btreeCursor;
#endif
}




- (IXStore *)store;







- addEntryNamed:(const char *)aName ofClass:aClass;
- addEntryNamed:(const char *)aName ofClass:aClass atBlock:(unsigned)aHandle;
- addEntryNamed:(const char *)aName forObject:anObject;


- (const char **)entries;


- (const char *)entryNames;





- reset;
- removeName:(const char *)aName;

- empty;
- freeEntryNamed:(const char *)aName;




- (BOOL)hasEntryNamed:(const char *)aName;
- openEntryNamed:(const char *)aName;

- getBlock:(unsigned *)aBlock ofEntryNamed:(const char *)aName;
- getClass:(Class *)aClass ofEntryNamed:(const char *)aName;

@end
