/*
protocols.h
Copyright 1991,NeXT Computer,Inc.
*/

#import	<store/protocols.h>

typedef int 
IXComparator(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

#ifdef	NX_COMPILER_RELEASE_3_0
@protocol IXComparatorSetting
#else
@interface Object(IXComparatorSetting)
#endif




- getComparator:(IXComparator **)comparator andContext:(const void **)context;
- setComparator:(IXComparator *)comparator andContext:(const void *)context;

@end

#ifdef	NX_COMPILER_RELEASE_3_0
@protocol IXComparisonSetting
#else
@interface Object(IXComparisonSetting)
#endif




- (const char *)comparisonFormat;
- setComparisonFormat:(const char *)aFormat;

@end

#ifdef	NX_COMPILER_RELEASE_3_0
@protocol IXCursorPositioning
#else
@interface Object(IXCursorPositioning)
#endif

- (BOOL)setFirst;
- (BOOL)setLast;
- (BOOL)setNext;
- (BOOL)setPrevious;

- (BOOL)getKey:(const void **)key
    andLength:(unsigned *)length;
- (BOOL)setKey:(const void *)key
    andLength:(unsigned)length;

- (BOOL)isMatch;

@end





typedef struct IXPosting	{
    unsigned			handle;
    unsigned			weight;
} IXPosting;

#ifdef	NX_COMPILER_RELEASE_3_0
@protocol IXPostingExchange
#else
@interface Object(IXPostingExchange)
#endif




- getCount:(unsigned *)theCount andPostings:(IXPosting **)thePostings;
- setCount:(unsigned)theCount andPostings:(const IXPosting *)thePostings;

@end

#ifdef	NX_COMPILER_RELEASE_3_0
@protocol IXPostingOperations
#else
@interface Object(IXPostingOperations)
#endif

- addHandle:(unsigned)handle withWeight:(unsigned)weight;
- removeHandle:(unsigned)handle;

- empty;
- (unsigned)count;



- (unsigned)setFirstHandle;
- (unsigned)setNextHandle;


- (unsigned)setHandle:(unsigned)handle;
- (unsigned)getHandle:(unsigned *)handle andWeight:(unsigned *)weight;

@end



extern int 
IXFormatComparator(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, void *format);

extern int 
IXCompareStrings(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

extern int 
IXCompareMonocaseStrings(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

extern int 
IXCompareBytes(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

extern int 
IXCompareShort(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

extern int 
IXCompareShorts(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

extern int 
IXCompareLong(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

extern int 
IXCompareLongs(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

extern int 
IXCompareUnsignedBytes(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

extern int 
IXCompareUnsignedShort(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

extern int 
IXCompareUnsignedShorts(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

extern int 
IXCompareUnsignedLong(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

extern int 
IXCompareUnsignedLongs(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

extern int 
IXCompareFloat(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

extern int 
IXCompareFloats(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

extern int 
IXCompareDouble(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

extern int 
IXCompareDoubles(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

extern int 
IXCompareStringAndUnsigneds(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

extern int 
IXCompareUnsignedAndStrings(const void *data1, unsigned short length1, 
    const void *data2, unsigned short length2, const void *context);

