/* 	Copyright (c) 1992 NeXT Computer, Inc.  All rights reserved. 
 *
 * displayRegisters.h - i386-specific register helpers
 *
 *
 * HISTORY
 * 03 Aug 93	Scott Forstall
 *      Created. 
 */

#import <driverkit/i386/ioPorts.h>

static inline unsigned char IOReadRegister(
	IOEISAPortAddress port,
	unsigned char index)


{
    outb(port, index);
    return(inb(port + 1));
}

static inline void IOWriteRegister(
	IOEISAPortAddress port,
	unsigned char index,
	unsigned char value)

{
    outb(port, index);
    outb(port + 1, value);
}

static inline void IOReadModifyWriteRegister(
	IOEISAPortAddress port,
	unsigned char index,
	unsigned char protect,
	unsigned char value)



{
    unsigned char val = IOReadRegister(port, index);
    IOWriteRegister(port, index, (val & protect) | value);
}

