/*
IXAttributeReader.h
Copyright 1991, NeXT Computer, Inc.
*/

#import	<objc/Object.h>
#import	<objc/hashtable.h>

@class List;






@protocol IXLexemeExtraction

- (unsigned)foldCase:(char *)string inLength:(unsigned)length;
- (unsigned)getLexeme:(char *)string inLength:(unsigned)length 
    fromStream:(NXStream *)stream;

@end

@interface IXAttributeReader: Object
{
    NXHashTable		*stopWords;
    const char 		*punctuation;
    unsigned char	*charMapping;
    struct		{
	unsigned	caseFolding:1;
	unsigned	pluralFolding:1;
	unsigned	stemsReduced:1;
	unsigned	tokenUniquing:1;
    } 			booleanOptions;
}


- (NXStream *)analyzeStream:(NXStream *)stream;

- (unsigned)foldPlural:(char *)string inLength:(unsigned)length;
- (unsigned)reduceStem:(char *)string inLength:(unsigned)length;

@end

@interface IXAttributeReader(Configuration)

- (BOOL)isCaseFolded;
- setCaseFolded:(BOOL)flag;

- (BOOL)arePluralsFolded;
- setPluralsFolded:(BOOL)flag;

- (BOOL)areStemsReduced;
- setStemsReduced:(BOOL)flag;

- (char *)punctuation;
- setPunctuation:(const char *)string;

- (char *)stopWords;
- setStopWords:(const char *)string;

- readStopWords:(NXStream *)stream;
- writeStopWords:(NXStream *)stream;

- readStopWordsFromFile:(const char *)filename;
- writeStopWordsToFile:(const char *)filename;

@end




@protocol IXAttributeReading

- (NXStream *)analyzeStream:(NXStream *)stream;

@end

