/*
IXFileRecord.h
Copyright 1991, NeXT Computer, Inc.
*/

#import	<bsd/sys/stat.h>
#import	<objc/hashtable.h>
#import	<objc/Object.h>
#import	<remote/transport.h>

#import	"protocols.h"

@class IXFileFinder;



extern NXAtom	IXFileNameAttribute;
extern NXAtom	IXBaseNameAttribute;
extern NXAtom	IXFileTypeAttribute;
extern NXAtom	IXFileDeviceAttribute;
extern NXAtom	IXFileInodeAttribute;
extern NXAtom	IXFileModeAttribute;
extern NXAtom	IXFileLinksAttribute;
extern NXAtom	IXFileOwnerAttribute;
extern NXAtom	IXFileGroupAttribute;
extern NXAtom	IXFileSizeAttribute;
extern NXAtom	IXAccessTimeAttribute;
extern NXAtom	IXModifyTimeAttribute;
extern NXAtom	IXChangeTimeAttribute;
extern NXAtom	IXUnixTypeAttribute;


typedef enum IXUnixType	{
    IXUnixFile, IXUnixDirectory, 
	IXUnixBlock, IXUnixCharacter, IXUnixLink, IXUnixSocket
} IXUnixType;

@interface IXFileRecord: Object <NXTransport, IXAttributeBinding>
{
    id			_bindings;
@public
    unsigned		filedate;
    IXFileFinder	*fileFinder;
    char		*filename;
    char		*filetype;
    char		*description;
    struct stat		*statBuffer;
}

- (IXFileFinder *)fileFinder;
- initWithFileFinder:(IXFileFinder *)aFinder;
- setFileFinder:(IXFileFinder *)aFinder;

- (const struct stat *)statBuffer;

- (IXUnixType)unixType;

- (ino_t)fileInode;
- (dev_t)fileDevice;

- (unsigned short)fileMode;
- (short)fileLinks;

- (gid_t)fileGroup;
- (uid_t)fileOwner;

- (off_t)fileSize;

- (time_t)accessTime;
- (time_t)changeTime;
- (time_t)modifyTime;

- (BOOL)hasBindings;
- (IXAttributeBinder *)attributeBinder;
- freeBindings;

- (const char *)filename;
- setFilename:(const char *)name;
- (const char *)basename;

- (const char *)filetype;
- setFiletype:(const char *)type;

- (const char *)description;
- setDescription:(const char *)aDescription;

- (unsigned)filedate;
- setFiledate:(unsigned)date;

@end

