/*
IXWeightingDomain.h
Copyright 1991, NeXT Computer, Inc.
*/

#import	<objc/Object.h>
#import	<objc/hashtable.h>

@class IXAttributeParser, IXAttributeTable;

@interface IXWeightingDomain: Object
{
    unsigned	beenRanked;
    unsigned	totalTokens;
    unsigned	uniqueTokens;
    unsigned	indexCount;
    unsigned	totalLength;
    void	*tokenArray;
    unsigned	*tokenIndex;
}

- initFromDomain:(NXStream *)stream;
- writeDomain:(NXStream *)stream;

- initFromHistogram:(NXStream *)stream;
- writeHistogram:(NXStream *)stream;

- initFromWFTable:(NXStream *)stream;


- initFromAttributeTable:(IXAttributeTable *)theTable;




- initFromAttributeParser:(IXAttributeParser *)aParser;
- initFromAttributeParser:(IXAttributeParser *)aParser
    forAttributeNamed:(const char *)name;

- (unsigned)totalTokens;
- (unsigned)uniqueTokens;

- (unsigned)countForToken:(void *)token
    ofLength:(unsigned)aLength;
- (unsigned)rankForToken:(void *)token
    ofLength:(unsigned)aLength;

- (float)frequencyOfToken:(void *)token
    ofLength:(unsigned)aLength;
- (float)peculiarityOfToken:(void *)token
    ofLength:(unsigned)aLength andFrequency:(float)frequency;



- (NXHashState)initHashState;
- (BOOL)nextHashState:(NXHashState *)aState 
    value:(const void **)aValue length:(unsigned *)aLength;

@end

