/*
IXStore.h
Copyright 1991, NeXT Computer, Inc.
*/

#import	"protocols.h"
#import <mach/mach.h>
#import	<objc/hashtable.h>
#import	<objc/Object.h>

@class	NXData;




extern NXAtom	IXStorePboardType;

@interface IXStore: Object
{
@public
    unsigned			changeCount;
@private
    unsigned			nestingLevel;
    struct StoreBlockServer	*blockServer;
    struct StoreBroker		*storeBroker;
    struct StoreTransRecord	*queueForward;
    struct StoreTransRecord	*queueReverse;
    struct 			{
	unsigned		exceptions:1;
	unsigned		freeOnWrite:1;
	unsigned		RESERVED1:30;
    }				_storeStatus;
}







- enableExceptions:(BOOL)aBoolean;
- (BOOL)areExceptionsEnabled;





- copy;





- free;

- init;





- freeOnWrite;
- (BOOL)willFreeOnWrite;
















- createBlock:(unsigned *)handle ofSize:(unsigned)size;





- freeBlock:(unsigned)handle;

- (BOOL)blockExists:(unsigned)blockHandle;
- abortBlock:(unsigned)handle;
- closeBlock:(unsigned)handle;




- (unsigned)copyBlock:(unsigned)handle 
    atOffset:(unsigned)offset forLength:(unsigned)length;






- (void *)openBlock:(unsigned)handle
    atOffset:(unsigned)offset forLength:(unsigned)length;
- (void *)readBlock:(unsigned)handle
    atOffset:(unsigned)offset forLength:(unsigned)length;





- copyData:(void *)data toBlock:(unsigned)handle
    atOffset:(unsigned)offset forLength:(unsigned)length;







- (NXData *)exportBlock:(unsigned)handle 
    atOffset:(unsigned)offset forLength:(unsigned)length;
- importBlock:(unsigned)handle 
    atOffset:(unsigned)offset fromData:(NXData *)data;








- (unsigned)sizeOfBlock:(unsigned)handle;
- resizeBlock:(unsigned)handle toSize:(unsigned)size;

















- (unsigned)startTransaction;
- abortTransaction;
- commitTransaction;

- (unsigned)nestingLevel;
- (BOOL)areTransactionsEnabled;
- (int)changeCount;




- (unsigned)count;




- (unsigned)capacity;





- empty;





- compact;
- compactWithTimeout:(int)msecs;






- setSizeLimit:(vm_size_t)limit;
- (vm_size_t)sizeLimit;

- (vm_size_t)apparentSize;
- (vm_size_t)residentSize;






- getContents:(vm_address_t *)data andLength:(vm_size_t *)length;
- setContents:(vm_address_t)data andLength:(vm_size_t)length;


- copyFromStore:(IXStore *)aStore;

@end

