/*
IXStoreBlock.h
Copyright 1991, NeXT Computer, Inc.
*/

#import	"protocols.h"
#import	"IXStore.h"

#import	<remote/transport.h>
#import <machkit/reference.h>
#import	<objc/Object.h>

extern unsigned 
IXWriteRootObjectToStore(IXStore *aStore, unsigned aHandle, id anObject);

extern id 
IXReadObjectFromStore(IXStore *aStore, unsigned aHandle, NXZone *aZone);






@interface IXStoreBlock: Object <NXReference,NXTransport,IXBlockAndStoreAccess>
{
    unsigned		_references;
@public
    IXStore		*store;
    unsigned		handle;
    unsigned		blockSize;
@protected
    id			blockData;
    unsigned		readOffset;
    unsigned		readLength;
}




- (IXStore *)store;




- close;







- (unsigned char *)readAtOffset:(unsigned)offset forLength:(unsigned)length;




- (unsigned)readOffset;
- (unsigned)readLength;






- writeAtOffset:(unsigned)offset forLength:(unsigned)length;


- (unsigned)copyAtOffset:(unsigned)offset forLength:(unsigned)length;

- (unsigned)size;





- resizeTo:(unsigned)size;




- readObject;





- writeObject:anObject;





- (unsigned char *)openAtOffset:(unsigned)offset forLength:(unsigned)length;

@end

