/*
protocols.h
Copyright 1991,NeXT Computer,Inc.
*/

#import	<objc/objc.h>

@class IXStore;

#define IX_STOREUSERERRBASE	(9000)
#define IX_STOREMACHERRBASE	IX_STOREUSERERRBASE + (100)
#define IX_STOREUNIXERRBASE	IX_STOREUSERERRBASE + (300)

typedef enum IXStoreErrorType	{
    IX_NoError = IX_STOREUSERERRBASE, 
    IX_InternalError, 
    IX_ArgumentError, 
    IX_QueryEvalError, 
    IX_QueryTypeError, 
    IX_QueryAttrError, 
    IX_QueryImplError, 
    IX_QueryYaccError, 
    IX_MemoryError, 
    IX_LockedError, 
    IX_MachineError, 
    IX_VersionError, 
    IX_DamagedError, 
    IX_DuplicateError, 
    IX_NotFoundError, 
    IX_TooLargeError, 
    IX_UnixErrorBase = IX_STOREUNIXERRBASE, 
    IX_MachErrorBase = IX_STOREMACHERRBASE
} IXStoreErrorType;







@protocol IXBlockAndStoreAccess





+ freeFromBlock:(unsigned)aHandle inStore:(IXStore *)aStore;




- freeFromStore;





- getBlock:(unsigned *)aHandle andStore:(IXStore **)aStore;





- initInStore:(IXStore *)aStore;




- initFromBlock:(unsigned)aHandle inStore:(IXStore *)aStore;

@end






@protocol IXNameAndFileAccess <IXBlockAndStoreAccess>




+ freeFromName:(const char *)aName inFile:(const char *)aFile;





- getName:(const char **)aName andFile:(const char **)aFile;





- initWithName:(const char *)aName inFile:(const char *)aFile;




- initFromName:(const char *)aName inFile:(const char *)aFile 
    forWriting:(BOOL)writingFlag;

@end

